/*
 *    VisNow
 *    Copyright (C) 2006-2019 University of Warsaw, ICM
 *    Copyright (C) 2020 onward visnow.org
 *    All rights reserved. 
 *
 *  This file is part of GNU Classpath.
 *
 *  GNU Classpath is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *
 *  GNU Classpath is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with GNU Classpath; see the file COPYING.  If not, write to the
 *  University of Warsaw, Interdisciplinary Centre for Mathematical and
 *  Computational Modelling, Pawinskiego 5a, 02-106 Warsaw, Poland.
 *
 *  Linking this library statically or dynamically with other modules is
 *  making a combined work based on this library.  Thus, the terms and
 *  conditions of the GNU General Public License cover the whole
 *  combination.
 *
 *  As a special exception, the copyright holders of this library give you
 *  permission to link this library with independent modules to produce an
 *  executable, regardless of the license terms of these independent
 *  modules, and to copy and distribute the resulting executable under
 *  terms of your choice, provided that you also meet, for each linked
 *  independent module, the terms and conditions of the license of that
 *  module.  An independent module is a module which is not derived from
 *  or based on this library.  If you modify this library, you may extend
 *  this exception to your version of the library, but you are not
 *  obligated to do so.  If you do not wish to do so, delete this
 *  exception statement from your version.
 */
 
package org.visnow.vn.lib.gui;

import java.awt.event.ItemEvent;
import java.util.ArrayList;
import java.util.Vector;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import org.visnow.jscic.DataContainerSchema;
import org.visnow.jscic.dataarrays.DataArraySchema;

/**
 *
 * @author Krzysztof S. Nowinski, University of Warsaw, ICM
 */
public class DataComponentSelector extends javax.swing.JPanel
{

    protected DataContainerSchema dataSchema = null;
    protected boolean scalarComponentsOnly = false;
    protected boolean vectorComponentsOnly = false;
    protected boolean symmetricMatrixComponentsOnly = false;
    protected boolean addNullComponent = false;
    protected boolean numericComponentsOnly = true;
    protected int nScalarComps = 0;
    protected int nSymmetricMatrixComps = 0;
    protected int nVectorComps = 0;
    protected int nNumericComps = 0;
    protected int nItems = 0;
    protected int nComps = 0;
    protected Vector<String> compNames = new Vector<String>();
    protected int[] compIndices;
    protected boolean startNull = false;
    protected boolean active = true;
    protected String[] extraNames = null;
    protected int[] extraIndices;

    /**
     * Creates new form DataComponentSelector
     */
    public DataComponentSelector()
    {
        initComponents();
    }

    /**
     * This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents()
    {

        cmpComboBox = new org.visnow.vn.gui.widgets.SteppedComboBox();

        setOpaque(false);
        setLayout(new java.awt.BorderLayout());

        cmpComboBox.setPopupWidth(10);
        cmpComboBox.setPreferredSize(new java.awt.Dimension(33, 24));
        cmpComboBox.addItemListener(new java.awt.event.ItemListener()
        {
            public void itemStateChanged(java.awt.event.ItemEvent evt)
            {
                cmpComboBoxItemStateChanged(evt);
            }
        });
        add(cmpComboBox, java.awt.BorderLayout.CENTER);
    }// </editor-fold>//GEN-END:initComponents

    private void cmpComboBoxItemStateChanged(java.awt.event.ItemEvent evt)//GEN-FIRST:event_cmpComboBoxItemStateChanged
    {//GEN-HEADEREND:event_cmpComboBoxItemStateChanged
        //TODO: wrapped ComboBox and WidgetEvent should be used instead
        if (active && evt.getStateChange() == ItemEvent.SELECTED) //fire event only when item was selected (another event is fired at the same time which is deselection of other component)
            fireStateChanged();
    }//GEN-LAST:event_cmpComboBoxItemStateChanged

    public void setTitle(String title)
    {
        setBorder(javax.swing.BorderFactory.createTitledBorder(title));
    }

    protected void updateComponentNames(DataContainerSchema schema)
    {
        active = false;
        if (schema == null) {
            nComps = 0;
            cmpComboBox.setModel(new javax.swing.DefaultComboBoxModel());
            return;
        }
        ArrayList<DataArraySchema> components = schema.getComponentSchemas();
        nComps = components.size();
        compNames.clear();
        nItems = 0;
        if (extraNames != null && extraIndices != null && extraIndices.length == extraNames.length)
            compIndices = new int[nComps + extraIndices.length + 1];
        else
            compIndices = new int[nComps + 1];
        if (scalarComponentsOnly) {
            nScalarComps = 0;
            for (int i = 0; i < nComps; i++)
                if (components.get(i).getVectorLength() == 1 && (!numericComponentsOnly || components.get(i).isNumeric())) {
                    compNames.add(components.get(i).getName());
                    compIndices[nScalarComps] = i;
                    nScalarComps++;
                    nItems++;
                }
        } else if (symmetricMatrixComponentsOnly) {
            nSymmetricMatrixComps = 0;
            for (int i = 0; i < nComps; i++)
                if (components.get(i).isSymmetric() &&
                    components.get(i).isNumeric() &&
                    (!numericComponentsOnly || components.get(i).isNumeric())) {
                    compNames.add(components.get(i).getName());
                    compIndices[nSymmetricMatrixComps] = i;
                    nSymmetricMatrixComps++;
                    nItems++;
                }
        } else if (vectorComponentsOnly) {
            nVectorComps = 0;
            for (int i = 0; i < nComps; i++)
                if (components.get(i).getVectorLength() > 1 && (!numericComponentsOnly || components.get(i).isNumeric())) {
                    compNames.add(components.get(i).getName());
                    compIndices[nVectorComps] = i;
                    nVectorComps++;
                    nItems++;
                }
        } else if (numericComponentsOnly) {
            nNumericComps = 0;
            for (int i = 0; i < nComps; i++)
                if (components.get(i).isNumeric()) {
                    compNames.add(components.get(i).getName());
                    compIndices[nNumericComps] = i;
                    nNumericComps++;
                    nItems++;
                }
        } else {
            for (int i = 0; i < nComps; i++) {
                compNames.add(components.get(i).getName());
                compIndices[i] = i;
            }
            nItems = nComps;
        }
        if (extraNames != null && extraIndices != null && extraIndices.length == extraNames.length)
            for (int i = 0; i < extraIndices.length; i++, nItems++) {
                compNames.add(extraNames[i]);
                compIndices[nItems] = extraIndices[i];
            }
        if (addNullComponent) {
            compNames.add("null");
            compIndices[nItems] = -1;
        }
        cmpComboBox.setModel(new javax.swing.DefaultComboBoxModel(compNames));
        //      System.out.println("startNull="+startNull);
        if (compNames.isEmpty() || startNull)
            cmpComboBox.setSelectedIndex(cmpComboBox.getItemCount() - 1);
        else
            cmpComboBox.setSelectedIndex(0);
        active = true;
        fireStateChanged();
    }

    public void setScalarComponentsOnly(boolean scalarComponentsOnly)
    {
        if (scalarComponentsOnly != this.scalarComponentsOnly) {
            this.scalarComponentsOnly = scalarComponentsOnly;
            if (dataSchema != null)
                updateComponentNames(dataSchema);
        }
    }

    public void setSymmetricMatrixComponentsOnly(boolean symmetricMatrixComponentsOnly)
    {
        if (symmetricMatrixComponentsOnly != this.symmetricMatrixComponentsOnly) {
            this.symmetricMatrixComponentsOnly = symmetricMatrixComponentsOnly;
            if (dataSchema != null)
                updateComponentNames(dataSchema);
        }
    }

    public void setAddNullComponent(boolean addNullComponent)
    {
        if (addNullComponent != this.addNullComponent) {
            this.addNullComponent = addNullComponent;
            if (dataSchema != null)
                updateComponentNames(dataSchema);
        }
    }

    public void setVectorComponentsOnly(boolean vectorComponentsOnly)
    {
        if (vectorComponentsOnly != this.vectorComponentsOnly) {
            this.vectorComponentsOnly = vectorComponentsOnly;
            if (dataSchema != null)
                updateComponentNames(dataSchema);
        }
    }

    public void setDataSchema(DataContainerSchema schema)
    {
        if (schema == null || schema.isCompatibleWith(dataSchema))
            return;
        updateComponentNames(schema);
        dataSchema = schema;
        if (startNull && addNullComponent)
            cmpComboBox.setSelectedIndex(cmpComboBox.getItemCount() - 1);
        else {
            if (cmpComboBox.getModel().getSize() > 0)
                cmpComboBox.setSelectedIndex(0);
            else
                cmpComboBox.setSelectedIndex(-1);
        }
    }

    public void setSelectedIndex(int n)
    {
        cmpComboBox.setSelectedIndex(n);
    }

    public void setNull()
    {
        cmpComboBox.setSelectedItem("null");
    }

    public boolean isNullSelected()
    {
        return (addNullComponent && cmpComboBox.getSelectedIndex() == compNames.size() - 1);
    }

    public boolean isNumericComponentsOnly()
    {
        return numericComponentsOnly;
    }

    public void setNumericComponentsOnly(boolean numericComponentsOnly)
    {
        this.numericComponentsOnly = numericComponentsOnly;
    }

    public int getComponent()
    {
        if (isNullSelected())
            return -1;
        int k = cmpComboBox.getSelectedIndex();
        if (k < 0 || k >= compIndices.length)
            return -1;
        return compIndices[k];
    }

    public void setComponent(int k)
    {
        if (k < 0 && addNullComponent) {
            cmpComboBox.setSelectedIndex(cmpComboBox.getItemCount() - 1);
            return;
        }

        if (k >= nComps)
            return;
        
        if (k < 0 && extraIndices != null && extraNames != null) {
            for (int i = 0; i < extraIndices.length; i++) {
                if(extraIndices[i] == k) {
                    setComponentName(extraNames[i]);
                    break;
                } 
            }
        } 
        for (int i = 0; i < compIndices.length; i++) {
            if (compIndices[i] == k) {
                cmpComboBox.setSelectedIndex(i);
                break;
            }
        }
    }
    
    public String getComponentName()
    {
        return (String)cmpComboBox.getSelectedItem();
    }

    public void setComponentName(String name)
    {
        cmpComboBox.setSelectedItem(name);
    }

    public int getnItems()
    {
        return nItems;
    }

    public int getnScalarComps()
    {
        return nScalarComps;
    }

    public int getnVectorComps()
    {
        return nVectorComps;
    }

    public int getnNumericComps()
    {
        return nNumericComps;
    }

    public void addExtraItems(String[] names, int[] ind)
    {
        extraNames = names;
        extraIndices = ind;
        updateComponentNames(dataSchema);
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private org.visnow.vn.gui.widgets.SteppedComboBox cmpComboBox;
    // End of variables declaration//GEN-END:variables
    /**
     * Utility field holding list of ChangeListeners.
     */
    protected transient ArrayList<ChangeListener> changeListenerList = new ArrayList<ChangeListener>();

    /**
     * Registers ChangeListener to receive events.
     * <p>
     * @param listener The listener to register.
     */
    public synchronized void addChangeListener(ChangeListener listener)
    {
        changeListenerList.add(listener);
    }

    /**
     * Removes ChangeListener from the list of listeners.
     * <p>
     * @param listener The listener to remove.
     */
    public synchronized void removeChangeListener(ChangeListener listener)
    {
        changeListenerList.remove(listener);
    }

    /**
     * Notifies all registered listeners about the event.
     *
     * @param object Parameter #1 of the <CODE>ChangeEvent<CODE> constructor.
     */
    protected void fireStateChanged()
    {
        ChangeEvent e = new ChangeEvent(this);
        for (ChangeListener listener : changeListenerList) {
            listener.stateChanged(e);
        }
    }

    public void setStartNull(boolean startNull)
    {
        this.startNull = startNull;
    }

    @Override
    public void setEnabled(boolean enabled)
    {
        super.setEnabled(enabled);
        cmpComboBox.setEnabled(enabled);
    }
}
